<script setup lang="ts">
import { ref, watch, watchEffect } from "vue";
import { LMarker, LIcon } from "@vue-leaflet/vue-leaflet";
import imageCompression from 'browser-image-compression';
import Intervention from "../../../types/intervention";
import Category from "../../../types/category";
import Priority from "../../../types/priority";
import Type from "../../../types/type";
import User from "../../../types/user";

definePageMeta({
  middleware: "authentication",
});

// Récupération des droits :
const tokenCookie = getToken() ?? "";
const decodedToken = getDecodedToken(tokenCookie);
const currentUserId = getCurrentUserId(decodedToken);
const currentEmployerId = getCurrentEmployerId(decodedToken);
const imageCompressor = imageCompression;

// Etape formulaire
const currentStep = ref(1);
const labels = [
  "Photo",
  "Adresse",
  "Priorité de l'intervention",
  "Catégorie",
  "Type d’intervention",
  "Description",
];

if (
  decodedToken.roles.includes("ROLE_ADD_PARTICIPANTS_TO_INTERVENTION") === true
) {
  labels.push("Assigner cette intervention");
}

function nextStep() {
  currentStep.value++;
}

function previousStep() {
  currentStep.value--;
}

// Transformation Date en iso
const currentDate: { value: string } = { value: "" };
const date = new Date();
currentDate.value = date.toISOString();

// Récupération de la photo + url
let imageData = ref("");
let pictureFile = ref();
function previewImage(event: Event) {
  pictureFile.value = event.target.files[0];
  
  const compressionOptions = {
    maxSizeMB: 0.2,
    maxWidthOrHeight: 1500,
    useWebWorker: true
  };
  imageCompressor(pictureFile.value, compressionOptions)
  .then((compressedPicture: Blob) => {
    pictureFile.value = compressedPicture;
  });

  const reader = new FileReader();
  reader.onload = () => {
    imageData.value = URL.createObjectURL(pictureFile.value);
  };
  reader.readAsDataURL(pictureFile.value);
}

// Appel API
const { baseURL } = useRuntimeConfig().app;
const { publicApiUrl } = useRuntimeConfig().public;
const authorizationHeader = useAuthorizationHeader("application/json");

const { id } = useRoute().params;
const { data: intervention } = await useFetch<Intervention>(
  baseURL + "api/interventions/" + id,
  {
    headers: authorizationHeader,
  }
);

const { data: priorities } = await useFetch<Priority>(baseURL + "api/priorities", {
  headers: authorizationHeader,
});

const { data: categories } = await useFetch<Category>(baseURL + "api/categories", {
  headers: authorizationHeader,
});

const { data: types } = await useFetch<Type>(baseURL + "api/types", {
  headers: authorizationHeader,
});

const { data: participants } = await useFetch<User>(
  baseURL + `api/employers/${currentEmployerId}/active-agents`,
  {
    headers: authorizationHeader,
  }
);

const zoomLevel = ref(20);
const isButtonDisabled = ref(false);

// Appel API BAN
const searchQuery = ref("");
const addresses = ref([]);
const addressesVisible = ref(true);
const selectedCoordinates = ref([
  intervention.value.location.latitude,
  intervention.value.location.longitude,
]);
const selectedAddress = ref(
  intervention.value.location.rest +
    " " +
    intervention.value.location.street +
    " " +
    intervention.value.location.postcode +
    " " +
    intervention.value.location.city
);

watchEffect(() => {
  if (searchQuery.value.length >= 3) {
    fetchData();
  } else {
    resetSearch();
  }
});

async function fetchData() {
  try {
    const response = await fetch(
      `https://api-adresse.data.gouv.fr/search/?q=${searchQuery.value}`
    );
    const data = await response.json();
    addresses.value = data.features;
    console.log(addresses.value);
  } catch (error) {
    console.error(error);
  }
}

watch(searchQuery, (newValue) => {
  if (newValue === "") {
    resetSearch();
  }
});

function resetSearch() {
  addresses.value = [];
  addressesVisible.value = true;
}

const formData = ref({
  description: "",
  status: "",
  priority: "",
  category: "",
  type: "",
  author: `/users/${currentUserId}`,
  employer: `/employers/${currentEmployerId}`,
  location: {
    rest: "",
    street: "",
    postcode: "",
    city: "",
    longitude: "",
    latitude: "",
  },
  participants: [],
});

const filteredTypes = ref([]);
function filterTypes(categoryId) {
  filteredTypes.value = types.value.filter(
    (type) => type.category === `/categories/${categoryId}`
  );
}
watch(
  () => formData.category,
  (newValue) => {
    if (newValue) {
      const categoryId = newValue.split("/")[2];
      filterTypes(categoryId);
    }
  }
);

// Adresse selectionnée
const selectedLocation = (address) => {
  selectedCoordinates.value = [
    address.geometry.coordinates[1],
    address.geometry.coordinates[0],
  ];
  selectedAddress.value = `${address.properties.name} ${address.properties.postcode} ${address.properties.city}`;

  if (!formData.value.location) {
    formData.value.location = {};
  }

  formData.value.location.rest = "";
  formData.value.location.street = address.properties.name
    ? `${address.properties.name}`
    : "";
  formData.value.location.postcode = address.properties.postcode;
  formData.value.location.city = address.properties.city;
  formData.value.location.longitude =
    address.geometry.coordinates[0].toString();
  formData.value.location.latitude = address.geometry.coordinates[1].toString();

  searchQuery.value = `${address.properties.name || ""} ${
    address.properties.postcode
  } ${address.properties.city}`;
  addressesVisible.value = false;
};

// Submit du form avec envoie sur la route post d'inter
async function submitForm() {
  try {
    const patchAuthorizationHeader = useAuthorizationHeader(
      "application/merge-patch+json"
    );
    const updateData = {};

    if (formData.value.description) {
      updateData.description = formData.value.description;
    }
    if (formData.value.priority) {
      updateData.priority = formData.value.priority;
    }
    if (formData.value.category) {
      updateData.category = formData.value.category;
    }
    if (formData.value.type) {
      updateData.type = formData.value.type;
    }
    if (
      formData.value.location &&
      Object.values(formData.value.location).some((value) => value !== "")
    ) {
      updateData.location = formData.value.location;
    }
    if (formData.value.participants && formData.value.participants.length > 0) {
      updateData.participants = formData.value.participants;
    }

    if (formData.value.participants.length >= 1) {
      formData.value.status = "/status/to-do";
    }

    if (Object.keys(updateData).length > 0) {
      await $fetch(`${baseURL}api/interventions/${id}`, {
        method: "PATCH",
        headers: patchAuthorizationHeader,
        body: updateData,
      });
      alert("Les données de l'intervention ont été mises à jour.");
    }

    if (imageData.value) {
      const pictureFormData = new FormData();
      const pictureDate = new Date();
      pictureFormData.append('picture_file', pictureFile.value, pictureFile.value.name);
      pictureFormData.append('intervention', `/interventions/${id}`);
      pictureFormData.append('createdAt', pictureDate.toISOString());
      pictureFormData.append('tags', `["/picture-tags/after"]`);

      /** @type {Parameters<fetch>[1]} */
      const fetchOptions = {
        // Pour l'envoi direct à l'API.
        headers: {"Authorization": "Bearer "+ tokenCookie},
        method: 'post',
        body: pictureFormData
      };

      await useFetch(
        publicApiUrl + "pictures",
        fetchOptions
      );
      console.log("La photo a bien été envoyé");

    }
    window.location.href = `/interventions/${intervention.value.id}`;
  } catch (error) {
    console.error(error);
    alert("Une erreur est survenue lors de l'envoi du formulaire.");
  }
}

/**
 * Géolocalise l'utilisateur.
 */
function useGeolocation() {
  navigator.geolocation.getCurrentPosition(onSuccessGeolocation, null, {
    enableHighAccuracy: true,
  });
}

/**
 * Lorsque l'on détecte la position.
 * @param {any} position la position.
 */
function onSuccessGeolocation(position: any) {
  selectedCoordinates.value = [
    position.coords.latitude,
    position.coords.longitude,
  ];

  // Recherche de l'adresse :
  $fetch(
    `https://api-adresse.data.gouv.fr/reverse/?lat=${position.coords.latitude}&lon=${position.coords.longitude}`
  )
    .then(onFoundAddress)
    .then(setNewAddress);
}

function draggedMarkerSearchLocation(event) {
  // Recherche de l'adresse :
  $fetch(
    `https://api-adresse.data.gouv.fr/reverse/?lat=${event.target._latlng.lat}&lon=${event.target._latlng.lng}`
  )
    .then(onFoundAddress)
    .then(setNewAddress);
}

/**
 * Lorsque la BAN a trouvé une adresse.
 * @param {any} response la réponse.
 */
function onFoundAddress(response: any) {
  if (
    response.features === undefined ||
    response.features[0] === undefined ||
    response.features[0].properties === undefined
  ) {
    return {};
  }

  const geometry = response.features[0].geometry;
  const properties = response.features[0].properties;

  return { geometry, properties };
}

/**
 * Définie la nouvelle adresse dans le champ input.
 * @param {any} address l'adresse.
 */
function setNewAddress(address: any) {
  let addressInput = document.getElementById("text-input-groups1");

  if (address !== {}) {
    addressInput.value =
      address.properties.name +
      " " +
      address.properties.postcode +
      " " +
      address.properties.city;

    formData.value.location.street = address.properties.name;
    formData.value.location.postcode = address.properties.postcode;
    formData.value.location.city = address.properties.city;
    formData.value.location.latitude =
      address.geometry.coordinates[1].toString();
    formData.value.location.longitude =
      address.geometry.coordinates[0].toString();
  } else {
    addressInput.value = "";
    formData.value.location.street = "";
    formData.value.location.postcode = "";
    formData.value.location.city = "";
  }
}
</script>

<template>
  <header>
    <div class="fr-grid-row fr-grid-row--middle">
      <div class="fr-col-2">
        <a
          href="/"
          class="fr-icon-arrow-left-line fr-p-3w"
          v-show="currentStep === 1"
        ></a>
        <button
          class="fr-icon-arrow-left-line fr-p-3w"
          v-show="currentStep > 1"
          @click="previousStep"
        ></button>
      </div>
      <h1
        class="fr-py-2w fr-grid-row fr-grid-row--center fr-col-9 address"
        v-text="selectedAddress"
      ></h1>
    </div>
  </header>

  <Stepper :current="currentStep" :labels="labels" :last="labels.length" />

  <section>
    <form class="fr-container fr-pt-3w" @submit.prevent="submitForm">
      <div
        class="fr-grid-row fr-grid-row--center fr-grid-row--middle"
        v-if="currentStep === 1"
      >
        <div
          class="fr-upload-group fr-grid-row fr-grid-row--middle fr-py-5w fr-px-3w photo"
        >
          <span class="fr-icon-camera-fill" aria-hidden="true"></span>
          <label class="fr-label" for="file-upload">Prendre une photo </label>
          <input
            type="file"
            ref="fileInput"
            capture="environment"
            accept="image/*"
            id="file-upload"
            name="file-upload"
            @change="previewImage"
          />
        </div>
        <div v-if="imageData">
          <img class="fr-responsive-img" :src="imageData" />
        </div>
      </div>
      <div v-if="currentStep === 2">
        <div class="fr-input-group adresse">
          <label class="fr-label" for="text-input-groups1">
            Lieu de l’intervention :
          </label>

          <input
            class="fr-input item"
            type="text"
            id="text-input-groups1"
            name="text-input-groups1"
            v-model="searchQuery"
          />

          <ul v-if="addresses && addressesVisible && searchQuery !== ''">
            <li
              class="item"
              v-for="address in addresses"
              :key="address.properties.id"
              :class="{ 'item-highlighted': address.highlighted }"
              @pointerover="address.highlighted = !address.highlighted"
              @click="selectedLocation(address)"
            >
              {{ address.properties.name }} {{ address.properties.postcode }}
              {{ address.properties.city }}
            </li>
          </ul>
        </div>

        <Map :lat-lng="selectedCoordinates" :zoom="zoomLevel" class="map">
          <LMarker
            :lat-lng="selectedCoordinates"
            draggable
            @dragend="draggedMarkerSearchLocation"
          >
            <LIcon :icon-url="usePinPicture()" />
          </LMarker>

          <button
            type="button"
            class="button-geo fr-grid-row fr-grid-row--middle fr-grid-row--center"
            @click.stop="useGeolocation"
          >
            <span class="fr-icon-send-plane-line"></span>
          </button>
        </Map>
      </div>
      <div v-if="currentStep === 3">
        <div class="fr-form-group">
          <fieldset class="fr-fieldset">
            <div class="fr-fieldset__content">
              <div class="fr-radio-group" v-for="p in priorities">
                <input
                  type="radio"
                  :id="`radio-${p.id}`"
                  name="radio"
                  :value="`/priorities/${p.id}`"
                  v-model="formData.priority"
                />
                <label class="fr-label" :for="`radio-${p.id}`">
                  {{ p.name }}
                </label>
              </div>
            </div>
          </fieldset>
        </div>
      </div>
      <div v-if="currentStep === 4" class="scrollable fr-p-2w">
        <div class="fr-form-group">
          <fieldset class="fr-fieldset">
            <div class="fr-fieldset__content">
              <div
                class="fr-radio-group fr-radio-rich fr-mb-2v"
                v-for="c in categories"
              >
                <input
                  type="radio"
                  :id="`radio-rich-${c.id}`"
                  name="radio-rich"
                  :value="`/categories/${c.id}`"
                  v-model="formData.category"
                  @change="filterTypes(c.id)"
                />
                <label
                  class="fr-label fr-my-0 fr-py-0"
                  :for="`radio-rich-${c.id}`"
                >
                  {{ c.name }}
                </label>
                <div class="fr-radio-rich__pictogram">
                  <img
                    :src="`${c.picture}`"
                    :alt="`${c.picture}`"
                    width="80"
                    height="80"
                  />
                </div>
              </div>
            </div>
          </fieldset>
        </div>
      </div>
      <div v-if="currentStep === 5" class="scrollable fr-p-2w">
        <div class="fr-form-group">
          <fieldset class="fr-fieldset">
            <div class="fr-fieldset__content">
              <div
                class="fr-radio-group fr-radio-rich fr-mb-2v"
                v-for="t in filteredTypes"
              >
                <input
                  type="radio"
                  :id="`radio-rich-${t.id}`"
                  name="radio-rich"
                  :value="`/types/${t.id}`"
                  v-model="formData.type"
                />
                <label
                  class="fr-label fr-my-0 fr-py-0"
                  :for="`radio-rich-${t.id}`"
                >
                  {{ t.name }}
                </label>
                <div class="fr-radio-rich__pictogram">
                  <img
                    :src="`${t.picture}`"
                    :alt="`${t.picture}`"
                    width="80"
                    height="80"
                  />
                </div>
              </div>
            </div>
          </fieldset>
        </div>
      </div>
      <div v-if="currentStep === 6">
        <label class="fr-label" for="text-input-text">
          Description de l'intervention:
        </label>
        <textarea
          class="fr-input"
          type="text"
          id="text-input-text"
          name="text-input-text"
          v-model="formData.description"
        />
      </div>
      <div v-if="currentStep === 7">
        <div class="fr-form-group">
          <fieldset class="fr-fieldset">
            <div class="fr-fieldset__content">
              <div class="fr-checkbox-group" v-for="part in participants">
                <input
                  type="checkbox"
                  :id="`checkboxes-${part.id}`"
                  name="checkboxes"
                  :value="`/users/${part.id}`"
                  v-model="formData.participants"
                />
                <label class="fr-label" :for="`checkboxes-${part.id}`">
                  {{ part.firstname }} {{ part.lastname }}
                </label>
              </div>
            </div>
          </fieldset>
        </div>
      </div>
      <ul class="fr-btns-group fr-mt-2w">
        <li v-show="currentStep < labels.length">
          <button class="fr-btn fr-mx-0" type="button" @click="nextStep">
            Continuer
          </button>
        </li>

        <li v-show="currentStep === labels.length">
          <button
            class="fr-btn fr-mx-0"
            :disabled="isButtonDisabled"
            type="submit"
          >
            Valider
          </button>
        </li>
      </ul>
    </form>
  </section>
</template>

<style scoped>
header {
  height: var(--height-header);
}

h1.address {
  display: inline-block;
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
}

form {
  height: calc(100vh - var(--height-header) - var(--height-stepper));
}

a {
  background-image: none;
}

.photo {
  flex-direction: column;
  background-color: var(--grey-950-100);
  border-radius: 20px;
}

.photo label {
  display: flex;
  flex-direction: column;
  align-content: center;
  align-items: center;
}

input[type="file"] {
  height: 0;
  width: 0;
  overflow: hidden;
}

.adresse {
  position: relative;
}

.adresse ul {
  position: absolute;
  box-shadow: rgb(201, 211, 223) 0px 1px 4px;
  z-index: 1750;
  -webkit-transform: translate3d(0, 0, 999);
  transform: translate3d(0, 0, 999);
  width: 100%;
  background-color: rgb(255, 255, 255);
  border: 1px solid rgb(173, 185, 201);
  color: rgb(28, 28, 28);
  border-radius: 0px 0px 5px 5px;
  bottom: -202px;
}

.item {
  display: flex;
  flex-flow: row;
  -webkit-box-pack: justify;
  justify-content: space-between;
  -webkit-box-align: center;
  align-items: center;
  padding: 0.5em;
}

.item-highlighted {
  background-color: rgb(0, 83, 179);
  color: rgb(255, 255, 255);
}

.scrollable {
  max-height: 60vh;
  overflow-y: auto;
}

textarea {
  box-shadow: 0 0 0 0.063rem var(--border-default-grey);
  height: 10.5rem;
}

ul {
  width: 100%;
  background-color: var(--background-default-grey);
  position: fixed;
  bottom: 0;
}

.map {
  height: 15.625rem;
}

.hidden-step {
  display: none;
}

.button-geo {
  border-radius: 63px;
  background: var(--background-default-grey);
  color: var(--background-active-blue-france);
  position: absolute;
  bottom: 1rem;
  right: 1rem;
  height: 2.5rem;
  width: 2.5rem;
  z-index: 400;
  box-shadow: 0px 10px 10px -6px #666;
}
.fr-radio-rich__pictogram img {
  max-height: 5rem;
  max-width: 5rem;
}
</style>
